constexpr ptr<byte> VramBack = (ptr<byte>)0x1000;
constexpr ptr<byte> VramFront = (ptr<byte>)0x1800;

constexpr byte VramWidth = 24;
constexpr byte VramHeight = 17;
constexpr byte VramStep = 2;
constexpr byte VramRowSize = 32*VramStep;

constexpr byte VramX = (28 - VramWidth) / 2;
constexpr byte VramY = (18 - VramHeight) / 2;
constexpr word OrgOffset = VramY * VramRowSize + VramX * VramStep;
constexpr ptr<byte> VramBackOrg = VramBack + OrgOffset;
constexpr ptr<byte> VramFrontOrg = VramFront + OrgOffset;

constexpr byte StatusHeight = 2;
constexpr byte StageTop = 1;

extern void ClearScreen();
extern word VramOffset(byte x, byte y);
extern ptr<byte> Put(ptr<byte> pVram, byte c);

extern ptr<byte> PrintC(ptr<byte> pVram, byte c);
extern void Put2C(ptr<byte> pVram, byte c);
